#ifndef Model_c
#define N0 4		/* 8d2 10h7 16q0 20d4 24d6 26h5 32q4 36s0 64o0 */
#define NN (2*N0)	/* immer klammern! */
#define N1 1
#define N2 0
#if (N1<2) && (N2<1)
#define Title "2-Orbitale 1D-PBC" 
#else
#define Title "2-Orbitale 2D-PBC"
#endif
#define Sym       1	/* x x 7 x x x x x x Symmetrien */
#define Sud       0
#define CM(JJ,tJ,tU) tU	  /* Heisenberg-,  t-J- or  Hubbard-model */
/* ================== Cu-Gitter nach Betts =========================== */
#if     (N1>1) || (N2>0)
#define Nw (4*N0)	/* 2D */
#else
#define Nw (3*N0)	/* 1D */
#endif
#define Ne NN
#define Nv N0
#endif
#define noSBase 1 	/* SBase/noSBase = mit/ohne Sym. */
#if Model_c
  /*  i=site 0..NN, d=translation rc=i+vec_d */
  int site_move(int i,int dx,int dy,...){ int orb;
    orb=i/N0;i%=N0;
    if(i<0 || orb>1)return -1;while(dx<0)dx+=N0/N1;while(dy<0)dy+=N1;
    i=(i+dx)%(N0/N1)+(i/(N0/N1))*(N0/N1);		/* x-direction */
    i=(i+dy+((i/(N0/N1)+dy)/N1)*(N2-N1+N0/N1))%(N0/N1)+
                   ((i/(N0/N1)+dy)%N1)*(N0/N1);		/* y-direction */
    return(i+orb*N0);}
  int initvars(){ int i;
#if   ((N1>1) || (N2>0)) && (N0==8)
    int j,tis[3][NN]={    /* besser: static int tis, int *is[], is=tis, ... */
    {2,3,0,1,6,7,4,5, 10,11, 8, 9,14,15,12,13},
    {1,0,3,2,7,6,5,4,  9, 8,11,10,15,14,13,12},
    {5,6,7,4,3,0,1,2, 13,14,15,12,11, 8, 9,10}}; 
    for(i=0;i<3;i++)for(j=0;j<NN;j++)sym.i[i][j]=tis[i][j];
#endif                     
#if ((N1>1) || (N2>0))		/* 2D-model */
    for(i=0;i<N0;i++){ 
       iw[i+0*N0][0]=i;iw[i+0*N0][1]=site_move(i,1,0);		/* tgg_x */
       iw[i+1*N0][0]=i;iw[i+1*N0][1]=site_move(i,0,1);		/* tgg_y */
       iw[i+2*N0][0]=i;iw[i+2*N0][1]=N0+site_move(i,i%2,1-i%2); /* tge   */
       iw[i+3*N0][0]=i+N0;iw[i+3*N0][1]=site_move(i,1-i%2,i%2);}/* tge   */
#else				/* 1D-model (Kette) */
    for(i=0;i<N0;i++){
     if(Sym>0){ sym.i[0][i]   = N0-i-1;           
                sym.i[0][i+N0]= N0-i-1+N0; }		/* refl */
     if(Sym>1){ sym.i[1][i]   =(i+N0/2)%N0;
                sym.i[1][i+N0]=(i+N0/2)%N0+N0; } }	/* transl N0/2 */
    for(i=0;i<N0;i++){
     iw[i+0*N0][0]=i;iw[i+0*N0][1]=(i+1)%N0; 		/* tgg */
     iw[i+1*N0][0]=i;iw[i+1*N0][1]=(i+1)%N0+N0;		/* tge */
     iw[i+2*N0][0]=i;iw[i+2*N0][1]=(i+N0-1)%N0+N0;}     /* teg */
#endif
    nu=N0/2;nd=N0/2+N0%2;
    for(i=0;i<Nw;i++)wt[i]=(i<Nw-2*N0)?1:2;
    for(i=0;i<NN;i++)wu[i]=3;
    for(i=0;i<NN;i++)we[i]=(i<N0)?4:5;
    for(i=0;i<N0;i++){iw2[i][0]=i;iw2[i][1]=i+N0;wu2[i]=6;wj2[i]=7;}
    numpara=8;
    para[0]= 0.0;	/* immer 0 */
    para[1]= 0.1;	/* tgg  */
    para[2]= 0.6;	/* tge  */
    para[3]=10.0;	/* U0   */
    para[4]= 0.0;	/* e_g  */
    para[5]= 0.5;	/* e_e  */
    para[6]= 8.0;	/* U = U0 + 2 JH */
    para[7]=-1.0;	/* JH */
    x_p=0;return 0;}
#endif 


